<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>WorkbookEvaluator (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="WorkbookEvaluator (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":9,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":9,"i9":9,"i10":10,"i11":10,"i12":10,"i13":10,"i14":9,"i15":9,"i16":10,"i17":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/WorkbookEvaluator.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/ss/formula/WorkbookDependentFormula.html"
               title="interface in org.apache.poi.ss.formula"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluatorProvider.html"
               title="interface in org.apache.poi.ss.formula"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/ss/formula/WorkbookEvaluator.html"
               target="_top">Frames</a></li>
        <li><a href="WorkbookEvaluator.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.ss.formula</div>
    <h2 title="Class WorkbookEvaluator" class="title">Class WorkbookEvaluator</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.ss.formula.WorkbookEvaluator</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <hr>
                <br>
                <pre><a href="../../../../../org/apache/poi/util/Internal.html"
                        title="annotation in org.apache.poi.util">@Internal</a>
public final class <span class="typeNameLabel">WorkbookEvaluator</span>
extends java.lang.Object</pre>
                <div class="block">Evaluates formula cells.<p/>

                    For performance reasons, this class keeps a cache of all previously calculated intermediate
                    cell values. Be sure to call <a
                            href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#clearAllCachedResultValues--"><code>clearAllCachedResultValues()</code></a>
                    if any workbook cells are changed between
                    calls to evaluate~ methods on this class.<br/>

                    For POI internal use only
                </div>
                <dl>
                    <dt><span class="simpleTagLabel">Author:</span></dt>
                    <dd>Josh Micich, Thies Wellpott (debug output enhancements)</dd>
                </dl>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#WorkbookEvaluator-org.apache.poi.ss.formula.EvaluationWorkbook-org.apache.poi.ss.formula.IStabilityClassifier-org.apache.poi.ss.formula.udf.UDFFinder-">WorkbookEvaluator</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationWorkbook.html"
                                        title="interface in org.apache.poi.ss.formula">EvaluationWorkbook</a>&nbsp;workbook,
                                    <a href="../../../../../org/apache/poi/ss/formula/IStabilityClassifier.html"
                                       title="interface in org.apache.poi.ss.formula">IStabilityClassifier</a>&nbsp;stabilityClassifier,
                                    <a href="../../../../../org/apache/poi/ss/formula/udf/UDFFinder.html"
                                       title="interface in org.apache.poi.ss.formula.udf">UDFFinder</a>&nbsp;udfFinder)</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>protected boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#adjustRegionRelativeReference-org.apache.poi.ss.formula.ptg.Ptg:A-org.apache.poi.ss.util.CellReference-org.apache.poi.ss.util.CellRangeAddressBase-">adjustRegionRelativeReference</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/formula/ptg/Ptg.html"
                                        title="class in org.apache.poi.ss.formula.ptg">Ptg</a>[]&nbsp;ptgs,
                                    <a href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                       title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;target,
                                    <a href="../../../../../org/apache/poi/ss/util/CellRangeAddressBase.html"
                                       title="class in org.apache.poi.ss.util">CellRangeAddressBase</a>&nbsp;region)</code>
                                    <div class="block">Adjust formula relative references by the offset between the
                                        start of the given region and the given target cell.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#clearAllCachedResultValues--">clearAllCachedResultValues</a></span>()</code>
                                    <div class="block">Should be called whenever there are changes to input cells in the
                                        evaluated workbook.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>static <a
                                        href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#dereferenceResult-org.apache.poi.ss.formula.eval.ValueEval-int-int-">dereferenceResult</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;evaluationResult,
                                    int&nbsp;srcRowNum,
                                    int&nbsp;srcColNum)</code>
                                    <div class="block">Dereferences a single value from any AreaEval or RefEval
                                        evaluation
                                        result.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#evaluate-org.apache.poi.ss.formula.EvaluationCell-">evaluate</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationCell.html"
                                        title="interface in org.apache.poi.ss.formula">EvaluationCell</a>&nbsp;srcCell)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#evaluate-java.lang.String-org.apache.poi.ss.util.CellReference-">evaluate</a></span>(java.lang.String&nbsp;formula,
                                    <a href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                       title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;ref)</code>
                                    <div class="block">Evaluate a formula outside a cell value, e.g.</div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#evaluate-java.lang.String-org.apache.poi.ss.util.CellReference-org.apache.poi.ss.util.CellRangeAddressBase-">evaluate</a></span>(java.lang.String&nbsp;formula,
                                    <a href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                       title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;target,
                                    <a href="../../../../../org/apache/poi/ss/util/CellRangeAddressBase.html"
                                       title="class in org.apache.poi.ss.util">CellRangeAddressBase</a>&nbsp;region)</code>
                                    <div class="block">Some expressions need to be evaluated in terms of an offset from
                                        the top left corner of a region,
                                        such as some data validation and conditional format expressions, when those
                                        constraints apply
                                        to contiguous cells.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#evaluateList-java.lang.String-org.apache.poi.ss.util.CellReference-org.apache.poi.ss.util.CellRangeAddressBase-">evaluateList</a></span>(java.lang.String&nbsp;formula,
                                    <a href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                       title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;target,
                                    <a href="../../../../../org/apache/poi/ss/util/CellRangeAddressBase.html"
                                       title="class in org.apache.poi.ss.util">CellRangeAddressBase</a>&nbsp;region)</code>
                                    <div class="block">Some expressions need to be evaluated in terms of an offset from
                                        the top left corner of a region,
                                        such as some data validation and conditional format expressions, when those
                                        constraints apply
                                        to contiguous cells.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/ss/formula/functions/FreeRefFunction.html"
                                        title="interface in org.apache.poi.ss.formula.functions">FreeRefFunction</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#findUserDefinedFunction-java.lang.String-">findUserDefinedFunction</a></span>(java.lang.String&nbsp;functionName)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code>static java.util.Collection&lt;java.lang.String&gt;</code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#getNotSupportedFunctionNames--">getNotSupportedFunctionNames</a></span>()</code>
                                    <div class="block">Return a collection of functions that POI does not support</div>
                                </td>
                            </tr>
                            <tr id="i9" class="rowColor">
                                <td class="colFirst"><code>static java.util.Collection&lt;java.lang.String&gt;</code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#getSupportedFunctionNames--">getSupportedFunctionNames</a></span>()</code>
                                    <div class="block">Return a collection of functions that POI can evaluate</div>
                                </td>
                            </tr>
                            <tr id="i10" class="altColor">
                                <td class="colFirst"><code>boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#isDebugEvaluationOutputForNextEval--">isDebugEvaluationOutputForNextEval</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i11" class="rowColor">
                                <td class="colFirst"><code>boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#isIgnoreMissingWorkbooks--">isIgnoreMissingWorkbooks</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i12" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#notifyDeleteCell-org.apache.poi.ss.formula.EvaluationCell-">notifyDeleteCell</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationCell.html"
                                        title="interface in org.apache.poi.ss.formula">EvaluationCell</a>&nbsp;cell)</code>
                                    <div class="block">Should be called to tell the cell value cache that the specified
                                        cell has just been
                                        deleted.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i13" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#notifyUpdateCell-org.apache.poi.ss.formula.EvaluationCell-">notifyUpdateCell</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationCell.html"
                                        title="interface in org.apache.poi.ss.formula">EvaluationCell</a>&nbsp;cell)</code>
                                    <div class="block">Should be called to tell the cell value cache that the specified
                                        (value or formula) cell
                                        has changed.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i14" class="altColor">
                                <td class="colFirst"><code>static void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#registerFunction-java.lang.String-org.apache.poi.ss.formula.functions.FreeRefFunction-">registerFunction</a></span>(java.lang.String&nbsp;name,
                                    <a href="../../../../../org/apache/poi/ss/formula/functions/FreeRefFunction.html"
                                       title="interface in org.apache.poi.ss.formula.functions">FreeRefFunction</a>&nbsp;func)</code>
                                    <div class="block">Register a ATP function in runtime.</div>
                                </td>
                            </tr>
                            <tr id="i15" class="rowColor">
                                <td class="colFirst"><code>static void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#registerFunction-java.lang.String-org.apache.poi.ss.formula.functions.Function-">registerFunction</a></span>(java.lang.String&nbsp;name,
                                    <a href="../../../../../org/apache/poi/ss/formula/functions/Function.html"
                                       title="interface in org.apache.poi.ss.formula.functions">Function</a>&nbsp;func)</code>
                                    <div class="block">Register a function in runtime.</div>
                                </td>
                            </tr>
                            <tr id="i16" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#setDebugEvaluationOutputForNextEval-boolean-">setDebugEvaluationOutputForNextEval</a></span>(boolean&nbsp;value)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i17" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#setIgnoreMissingWorkbooks-boolean-">setIgnoreMissingWorkbooks</a></span>(boolean&nbsp;ignore)</code>
                                    <div class="block">Whether to ignore missing references to external workbooks and
                                        use cached formula results in the main workbook instead.
                                    </div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="WorkbookEvaluator-org.apache.poi.ss.formula.EvaluationWorkbook-org.apache.poi.ss.formula.IStabilityClassifier-org.apache.poi.ss.formula.udf.UDFFinder-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>WorkbookEvaluator</h4>
                                <pre>public&nbsp;WorkbookEvaluator(<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationWorkbook.html"
                                        title="interface in org.apache.poi.ss.formula">EvaluationWorkbook</a>&nbsp;workbook,
                         <a href="../../../../../org/apache/poi/ss/formula/IStabilityClassifier.html"
                            title="interface in org.apache.poi.ss.formula">IStabilityClassifier</a>&nbsp;stabilityClassifier,
                         <a href="../../../../../org/apache/poi/ss/formula/udf/UDFFinder.html"
                            title="interface in org.apache.poi.ss.formula.udf">UDFFinder</a>&nbsp;udfFinder)</pre>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>udfFinder</code> - pass <code>null</code> for default (AnalysisToolPak
                                        only)
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="clearAllCachedResultValues--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>clearAllCachedResultValues</h4>
                                <pre>public&nbsp;void&nbsp;clearAllCachedResultValues()</pre>
                                <div class="block">Should be called whenever there are changes to input cells in the
                                    evaluated workbook.
                                    Failure to call this method after changing cell values will cause incorrect
                                    behaviour
                                    of the evaluate~ methods of this class
                                </div>
                            </li>
                        </ul>
                        <a name="notifyUpdateCell-org.apache.poi.ss.formula.EvaluationCell-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>notifyUpdateCell</h4>
                                <pre>public&nbsp;void&nbsp;notifyUpdateCell(<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationCell.html"
                                        title="interface in org.apache.poi.ss.formula">EvaluationCell</a>&nbsp;cell)</pre>
                                <div class="block">Should be called to tell the cell value cache that the specified
                                    (value or formula) cell
                                    has changed.
                                </div>
                            </li>
                        </ul>
                        <a name="notifyDeleteCell-org.apache.poi.ss.formula.EvaluationCell-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>notifyDeleteCell</h4>
                                <pre>public&nbsp;void&nbsp;notifyDeleteCell(<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationCell.html"
                                        title="interface in org.apache.poi.ss.formula">EvaluationCell</a>&nbsp;cell)</pre>
                                <div class="block">Should be called to tell the cell value cache that the specified cell
                                    has just been
                                    deleted.
                                </div>
                            </li>
                        </ul>
                        <a name="evaluate-org.apache.poi.ss.formula.EvaluationCell-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>evaluate</h4>
                                <pre>public&nbsp;<a href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                                    title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;evaluate(<a
                                        href="../../../../../org/apache/poi/ss/formula/EvaluationCell.html"
                                        title="interface in org.apache.poi.ss.formula">EvaluationCell</a>&nbsp;srcCell)</pre>
                            </li>
                        </ul>
                        <a name="dereferenceResult-org.apache.poi.ss.formula.eval.ValueEval-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>dereferenceResult</h4>
                                <pre>public static&nbsp;<a
                                        href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;dereferenceResult(<a
                                        href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;evaluationResult,
                                          int&nbsp;srcRowNum,
                                          int&nbsp;srcColNum)</pre>
                                <div class="block">Dereferences a single value from any AreaEval or RefEval evaluation
                                    result. If the supplied evaluationResult is just a plain value, it is
                                    returned as-is.
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>a <a href="../../../../../org/apache/poi/ss/formula/eval/NumberEval.html"
                                             title="class in org.apache.poi.ss.formula.eval"><code>NumberEval</code></a>,
                                        <a href="../../../../../org/apache/poi/ss/formula/eval/StringEval.html"
                                           title="class in org.apache.poi.ss.formula.eval"><code>StringEval</code></a>,
                                        <a href="../../../../../org/apache/poi/ss/formula/eval/BoolEval.html"
                                           title="class in org.apache.poi.ss.formula.eval"><code>BoolEval</code></a>, or
                                        <a href="../../../../../org/apache/poi/ss/formula/eval/ErrorEval.html"
                                           title="class in org.apache.poi.ss.formula.eval"><code>ErrorEval</code></a>.
                                        Never <code>null</code>. <a
                                                href="../../../../../org/apache/poi/ss/formula/eval/BlankEval.html"
                                                title="class in org.apache.poi.ss.formula.eval"><code>BlankEval</code></a>
                                        is
                                        converted to <a
                                                href="../../../../../org/apache/poi/ss/formula/eval/NumberEval.html#ZERO"><code>NumberEval.ZERO</code></a>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="findUserDefinedFunction-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>findUserDefinedFunction</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/ss/formula/functions/FreeRefFunction.html"
                                        title="interface in org.apache.poi.ss.formula.functions">FreeRefFunction</a>&nbsp;findUserDefinedFunction(java.lang.String&nbsp;functionName)</pre>
                            </li>
                        </ul>
                        <a name="evaluate-java.lang.String-org.apache.poi.ss.util.CellReference-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>evaluate</h4>
                                <pre>public&nbsp;<a href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                                    title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;evaluate(java.lang.String&nbsp;formula,
                          <a href="../../../../../org/apache/poi/ss/util/CellReference.html"
                             title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;ref)</pre>
                                <div class="block">Evaluate a formula outside a cell value, e.g. conditional format
                                    rules or data validation expressions
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>formula</code> - to evaluate</dd>
                                    <dd><code>ref</code> - defines the optional sheet and row/column base for the
                                        formula, if it is relative
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>value</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="evaluate-java.lang.String-org.apache.poi.ss.util.CellReference-org.apache.poi.ss.util.CellRangeAddressBase-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>evaluate</h4>
                                <pre>public&nbsp;<a href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                                    title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;evaluate(java.lang.String&nbsp;formula,
                          <a href="../../../../../org/apache/poi/ss/util/CellReference.html"
                             title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;target,
                          <a href="../../../../../org/apache/poi/ss/util/CellRangeAddressBase.html"
                             title="class in org.apache.poi.ss.util">CellRangeAddressBase</a>&nbsp;region)</pre>
                                <div class="block">Some expressions need to be evaluated in terms of an offset from the
                                    top left corner of a region,
                                    such as some data validation and conditional format expressions, when those
                                    constraints apply
                                    to contiguous cells. When a relative formula is used, it must be evaluated by
                                    shifting by the target
                                    offset position relative to the top left of the range.
                                    <p>
                                        Returns a single value e.g. a cell formula result or boolean value for
                                        conditional formatting.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>formula</code> -</dd>
                                    <dd><code>target</code> - cell context for the operation</dd>
                                    <dd><code>region</code> - containing the cell</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>value</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.IllegalArgumentException</code> - if target does not define a
                                        sheet name to evaluate the formula on.
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="evaluateList-java.lang.String-org.apache.poi.ss.util.CellReference-org.apache.poi.ss.util.CellRangeAddressBase-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>evaluateList</h4>
                                <pre>public&nbsp;<a href="../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                                    title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;evaluateList(java.lang.String&nbsp;formula,
                              <a href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                 title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;target,
                              <a href="../../../../../org/apache/poi/ss/util/CellRangeAddressBase.html"
                                 title="class in org.apache.poi.ss.util">CellRangeAddressBase</a>&nbsp;region)</pre>
                                <div class="block">Some expressions need to be evaluated in terms of an offset from the
                                    top left corner of a region,
                                    such as some data validation and conditional format expressions, when those
                                    constraints apply
                                    to contiguous cells. When a relative formula is used, it must be evaluated by
                                    shifting by the target
                                    offset position relative to the top left of the range.
                                    <p>
                                        Returns a ValueEval that may be one or more values, such as the allowed values
                                        for a data validation constraint.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>formula</code> -</dd>
                                    <dd><code>target</code> - cell context for the operation</dd>
                                    <dd><code>region</code> - containing the cell</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>ValueEval for one or more values</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.IllegalArgumentException</code> - if target does not define a
                                        sheet name to evaluate the formula on.
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="adjustRegionRelativeReference-org.apache.poi.ss.formula.ptg.Ptg:A-org.apache.poi.ss.util.CellReference-org.apache.poi.ss.util.CellRangeAddressBase-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>adjustRegionRelativeReference</h4>
                                <pre>protected&nbsp;boolean&nbsp;adjustRegionRelativeReference(<a
                                        href="../../../../../org/apache/poi/ss/formula/ptg/Ptg.html"
                                        title="class in org.apache.poi.ss.formula.ptg">Ptg</a>[]&nbsp;ptgs,
                                                <a href="../../../../../org/apache/poi/ss/util/CellReference.html"
                                                   title="class in org.apache.poi.ss.util">CellReference</a>&nbsp;target,
                                                <a href="../../../../../org/apache/poi/ss/util/CellRangeAddressBase.html"
                                                   title="class in org.apache.poi.ss.util">CellRangeAddressBase</a>&nbsp;region)</pre>
                                <div class="block">Adjust formula relative references by the offset between the start of
                                    the given region and the given target cell.
                                    That is, treat the region top-left cell as "A1" for the purposes of evaluating
                                    relative reference components (row and/or column),
                                    and further move references by the position of the target within the region.
                                    <p>
                                    <pre>formula ref + range top-left + current cell range offset </pre>
                                    </p>
                                    which simplifies to
                                    <p>
                                    <pre>formula ref + current cell ref</pre>
                                    </p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>ptgs</code> -</dd>
                                    <dd><code>target</code> - cell within the region to use.</dd>
                                    <dd><code>region</code> - containing the cell</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>true if any Ptg references were shifted</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.IndexOutOfBoundsException</code> - if the resulting shifted
                                        row/column indexes are over the document format limits
                                    </dd>
                                    <dd><code>java.lang.IllegalArgumentException</code> - if target is not within
                                        region.
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setIgnoreMissingWorkbooks-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setIgnoreMissingWorkbooks</h4>
                                <pre>public&nbsp;void&nbsp;setIgnoreMissingWorkbooks(boolean&nbsp;ignore)</pre>
                                <div class="block">Whether to ignore missing references to external workbooks and
                                    use cached formula results in the main workbook instead.
                                    <p>
                                        In some cases exetrnal workbooks referenced by formulas in the main workbook are
                                        not avaiable.
                                        With this method you can control how POI handles such missing references:
                                    <ul>
                                        <li>by default ignoreMissingWorkbooks=false and POI throws <a
                                                href="../../../../../org/apache/poi/ss/formula/CollaboratingWorkbooksEnvironment.WorkbookNotFoundException.html"
                                                title="class in org.apache.poi.ss.formula"><code>CollaboratingWorkbooksEnvironment.WorkbookNotFoundException</code></a>
                                            if an external reference cannot be resolved
                                        </li>
                                        <li>if ignoreMissingWorkbooks=true then POI uses cached formula result
                                            that already exists in the main workbook
                                        </li>
                                    </ul>
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>ignore</code> - whether to ignore missing references to external workbooks
                                    </dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd><a href="https://issues.apache.org/bugzilla/show_bug.cgi?id=52575">Bug 52575 for
                                        details</a></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="isIgnoreMissingWorkbooks--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>isIgnoreMissingWorkbooks</h4>
                                <pre>public&nbsp;boolean&nbsp;isIgnoreMissingWorkbooks()</pre>
                            </li>
                        </ul>
                        <a name="getSupportedFunctionNames--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getSupportedFunctionNames</h4>
                                <pre>public static&nbsp;java.util.Collection&lt;java.lang.String&gt;&nbsp;getSupportedFunctionNames()</pre>
                                <div class="block">Return a collection of functions that POI can evaluate</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>names of functions supported by POI</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getNotSupportedFunctionNames--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getNotSupportedFunctionNames</h4>
                                <pre>public static&nbsp;java.util.Collection&lt;java.lang.String&gt;&nbsp;getNotSupportedFunctionNames()</pre>
                                <div class="block">Return a collection of functions that POI does not support</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>names of functions NOT supported by POI</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="registerFunction-java.lang.String-org.apache.poi.ss.formula.functions.FreeRefFunction-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>registerFunction</h4>
                                <pre>public static&nbsp;void&nbsp;registerFunction(java.lang.String&nbsp;name,
                                    <a href="../../../../../org/apache/poi/ss/formula/functions/FreeRefFunction.html"
                                       title="interface in org.apache.poi.ss.formula.functions">FreeRefFunction</a>&nbsp;func)</pre>
                                <div class="block">Register a ATP function in runtime.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>name</code> - the function name</dd>
                                    <dd><code>func</code> - the functoin to register</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.IllegalArgumentException</code> - if the function is unknown or
                                        already registered.
                                    </dd>
                                    <dt><span class="simpleTagLabel">Since:</span></dt>
                                    <dd>3.8 beta6</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="registerFunction-java.lang.String-org.apache.poi.ss.formula.functions.Function-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>registerFunction</h4>
                                <pre>public static&nbsp;void&nbsp;registerFunction(java.lang.String&nbsp;name,
                                    <a href="../../../../../org/apache/poi/ss/formula/functions/Function.html"
                                       title="interface in org.apache.poi.ss.formula.functions">Function</a>&nbsp;func)</pre>
                                <div class="block">Register a function in runtime.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>name</code> - the function name</dd>
                                    <dd><code>func</code> - the functoin to register</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.IllegalArgumentException</code> - if the function is unknown or
                                        already registered.
                                    </dd>
                                    <dt><span class="simpleTagLabel">Since:</span></dt>
                                    <dd>3.8 beta6</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setDebugEvaluationOutputForNextEval-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setDebugEvaluationOutputForNextEval</h4>
                                <pre>public&nbsp;void&nbsp;setDebugEvaluationOutputForNextEval(boolean&nbsp;value)</pre>
                            </li>
                        </ul>
                        <a name="isDebugEvaluationOutputForNextEval--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>isDebugEvaluationOutputForNextEval</h4>
                                <pre>public&nbsp;boolean&nbsp;isDebugEvaluationOutputForNextEval()</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/WorkbookEvaluator.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/ss/formula/WorkbookDependentFormula.html"
               title="interface in org.apache.poi.ss.formula"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluatorProvider.html"
               title="interface in org.apache.poi.ss.formula"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/ss/formula/WorkbookEvaluator.html"
               target="_top">Frames</a></li>
        <li><a href="WorkbookEvaluator.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
